/*$
 Copyright (C) 2013-2025 Azel.

 This file is part of AzPainter.

 AzPainter is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 AzPainter is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
$*/

/****************************
 * 翻訳文字列ID
 ****************************/

/* グループID */

enum
{
	TRGROUP_WORD,
	TRGROUP_LISTEDIT,
	TRGROUP_STATUSBAR_HELP,
	TRGROUP_TOOLBAR_TOOLTIP,

	TRGROUP_PANEL_NAME = 10,
	TRGROUP_LAYER_TYPE,
	TRGROUP_BLENDMODE,
	TRGROUP_TOOL,
	TRGROUP_TOOL_SUB,
	TRGROUP_PIXELMODE_BRUSH,
	TRGROUP_PIXELMODE_TOOL,
	TRGROUP_RULE,

	TRGROUP_SELMATERIAL = 100,
	TRGROUP_TEXTTOOL_MENU,
	TRGROUP_SAVEDUP_MENU,

	//パネル
	TRGROUP_PANEL_IMAGEVIEWER = 1000,
	TRGROUP_PANEL_COLOR,
	TRGROUP_PANEL_COLOR_WHEEL,
	TRGROUP_PANEL_COLOR_PALETTE,
	TRGROUP_PANEL_CANVAS_VIEW,
	TRGROUP_PANEL_LAYER,
	TRGROUP_PANEL_OPTION,
	TRGROUP_PANEL_OPTION_TOOL,
	TRGROUP_PANEL_TOOLLIST_MENU,
	TRGROUP_PANEL_TOOLLIST_BRUSHSIZE,
	TRGROUP_PANEL_BRUSHOPT,

	//ダイアログ
	TRGROUP_DLG_TITLES = 1999,
	TRGROUP_DLG_VIEWER_OPTION = 2000,
	TRGROUP_DLG_NEWCANVAS,
	TRGROUP_DLG_GRIDOPT,
	TRGROUP_DLG_FILEDIALOG,
	TRGROUP_DLG_LAYER,
	TRGROUP_DLG_IMAGEOPT,
	TRGROUP_DLG_CANVAS,
	TRGROUP_DLG_SELECT_EXPAND,
	TRGROUP_DLG_GRADATION_EDIT,
	TRGROUP_DLG_BOXEDIT_SCALE,
	TRGROUP_DLG_TRANSFORM,
	TRGROUP_DLG_TEXT,
	TRGROUP_DLG_REGFONT,
	TRGROUP_DLG_TEXTWORDLIST,
	TRGROUP_DLG_TOOLLIST,
	TRGROUP_DLG_PRESSURE,
	TRGROUP_DLG_TOOLLIST_EDIT,
	TRGROUP_DLG_SAVEOPT,
	TRGROUP_DLG_KEYOPT,
	TRGROUP_DLG_FILTER,
	TRGROUP_DLG_PANEL_LAYOUT,
	TRGROUP_DLG_TOOLBAR_CUSTOMIZE,
	TRGROUP_DLG_ENVOPT,

	TRGROUP_MAINMENU = 10000,
	TRGROUP_MESSAGE,
	TRGROUP_ERRMES,
	TRGROUP_MESSAGE_DRAW
};

/* 単語 */
enum
{
	TRID_WORD_PREVIEW,
	TRID_WORD_NAME,
	TRID_WORD_WIDTH,
	TRID_WORD_HEIGHT,
	TRID_WORD_RESOLUTION,
	TRID_WORD_COLOR_BITS,
	TRID_WORD_DENSITY,
	TRID_WORD_COLOR,
	TRID_WORD_TYPE,
	TRID_WORD_BLENDMODE,
	TRID_WORD_OPACITY,
	TRID_WORD_TEXTURE,
	TRID_WORD_ANGLE,
	TRID_WORD_BKGND_COLOR,
	TRID_WORD_SIZE,
	TRID_WORD_UNIT,
	TRID_WORD_TEMPLATE,
	TRID_WORD_ANTIALIAS,
	TRID_WORD_PIXELMODE,
	TRID_WORD_DOTPEN_SHAPE,
	TRID_WORD_RESET
};

/* メッセージ */
enum
{
	TRID_MESSAGE_TITLE_CONFIRM,
	TRID_MESSAGE_DELETE_NO_RESTORE,
	TRID_MESSAGE_FAILED_LOAD,	//読み込みに失敗
	TRID_MESSAGE_FAILED_SAVE,	//保存に失敗
	TRID_MESSAGE_NOT_EXIST_RECENT_FILE,	//履歴ファイルが存在しない
	TRID_MESSAGE_FAILED_TEMPDIR,	//作業用ディレクトリの作成に失敗
	TRID_MESSAGE_SAVE_OVERWRITE,	//上書き保存
	TRID_MESSAGE_SAVE_OVERWRITE_APD,	//APD 以外での上書き保存
	TRID_MESSAGE_SAVE_CLOSE_CONFIRM,	//閉じる時の保存確認
	TRID_MESSAGE_CONVERT_VER2,			//ver2の設定ファイルを変換

	TRID_MESSAGE_TEXT_NO_ADD = 100,	//テキスト追加なし

	TRID_MESSAGE_FILTER_NO_COLOR = 200,
	TRID_MESSAGE_FILTER_NEED_CHECK,
	TRID_MESSAGE_FILTER_NEED_OPT_TEXTURE
};

/* エラーメッセージ */
enum
{
	TRID_ERRMES_ERROR,
	TRID_ERRMES_ALLOC,
	TRID_ERRMES_MAXSIZE,
	TRID_ERRMES_UNSUPPORTED,
	TRID_ERRMES_DAMAGED,
	TRID_ERRMES_SAVE_GIF_COLOR,
	TRID_ERRMES_SAVE_WEBP_SIZE
};

/* リスト編集 */
enum
{
	TRID_LISTEDIT_ADD,
	TRID_LISTEDIT_DEL,
	TRID_LISTEDIT_UP,
	TRID_LISTEDIT_DOWN,
	TRID_LISTEDIT_RENAME,
	TRID_LISTEDIT_COPY,
	TRID_LISTEDIT_EDIT
};

/* レイヤタイプ */
enum
{
	TRID_LAYERTYPE_FOLDER = 10,
	TRID_LAYERTYPE_TONE_GRAY,
	TRID_LAYERTYPE_TONE_A1,
	TRID_LAYERTYPE_TEXT_A,
	TRID_LAYERTYPE_TEXT_A1
};

/* ダイアログタイトル */
enum
{
	TRID_DLG_TITLE_GRADLIST_EDIT,
	TRID_DLG_TITLE_SET_IMAGE_POINT
};

